package me.mrletsplay.dynmapareas;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.dynmap.DynmapCommonAPI;
import org.dynmap.DynmapCommonAPIListener;
import org.dynmap.markers.MarkerAPI;
import org.dynmap.markers.MarkerSet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import me.mrletsplay.dynmapareas.command.Point;
import me.mrletsplay.dynmapareas.command.area.AreaCommand;
import me.mrletsplay.dynmapareas.command.marker.MarkerCommand;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.fabric.api.command.v2.CommandRegistrationCallback;
import net.minecraft.registry.RegistryKey;
import net.minecraft.world.World;

public class DynmapAreasMod implements ModInitializer {

	public static final Logger LOGGER = LoggerFactory.getLogger("dynmapareas");

	public static Map<UUID, List<Point>> points = new HashMap<>();
	public static MarkerAPI markerAPI;
	public static MarkerSet areaMarkerSet, markerMarkerSet;

	@Override
	public void onInitialize() {
		LOGGER.info("HELLO");

		DynmapCommonAPIListener.register(new DynmapCommonAPIListener() {

			@Override
			public void apiEnabled(DynmapCommonAPI api) {
				markerAPI = api.getMarkerAPI();
				areaMarkerSet = markerAPI.getMarkerSet("dynmapareas_areas");
				if(areaMarkerSet == null) areaMarkerSet = markerAPI.createMarkerSet("dynmapareas_areas", "Player Areas", null, true);
				markerMarkerSet = markerAPI.getMarkerSet("dynmapareas_markers");
				if(markerMarkerSet == null) markerMarkerSet = markerAPI.createMarkerSet("dynmapareas_markers", "Player Markers", null, true);
			}
		});


		CommandRegistrationCallback.EVENT.register((dispatcher, registryAccess, environment) -> {
			dispatcher.register(new AreaCommand().create());
			dispatcher.register(new MarkerCommand().create());
		});
	}

	// Taken from https://github.com/webbukkit/dynmap/blob/b8b1e8bd4e91f86e8017db8531c1e4faf37ce070/fabric-1.20/src/main/java/org/dynmap/fabric_1_20/FabricWorld.java#L39C5-L50C6
	public static String getWorldName(World w) {
		RegistryKey<World> rk = w.getRegistryKey();
		if (rk == World.OVERWORLD) { // Overworld?
			return w.getServer().getSaveProperties().getLevelName();
		} else if (rk == World.END) {
			return "DIM1";
		} else if (rk == World.NETHER) {
			return "DIM-1";
		} else {
			return rk.getValue().getNamespace() + "_" + rk.getValue().getPath();
		}
	}

}
