package me.mrletsplay.dynmapareas.command.area;

import java.util.Collections;
import java.util.stream.Collectors;

import org.dynmap.markers.AreaMarker;

import me.mrletsplay.dynmapareas.DynmapAreasMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import me.mrletsplay.mrcore.fabric.command.FabricCommandSender;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaDeleteCommand extends FabricCommand {

	public AreaDeleteCommand() {
		super("delete");
		setDescription("Delete an area from the map");
		setUsage("/area delete <id>");

		setTabCompleter(event -> {
			FabricCommandSender sender = (FabricCommandSender) event.getSender();
			ServerPlayerEntity p = sender.asPlayer();
			if(p == null) return Collections.emptyList();

			if(event.getArgs().length == 0) {
				String prefix = p.getUuid().toString() + "_";
				return DynmapAreasMod.areaMarkerSet.getAreaMarkers().stream()
						.filter(a -> a.getMarkerID().startsWith(prefix))
						.map(a -> a.getMarkerID().substring(prefix.length()))
						.collect(Collectors.toList());
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 1) {
			sendCommandInfo(event.getSender());
			return;
		}

		AreaMarker am = DynmapAreasMod.areaMarkerSet.findAreaMarker(p.getUuid().toString() + "_" + event.getArguments()[0]);
		if(am == null) {
			p.sendMessage(Text.literal("§cThat area doesn't exist"));
			return;
		}

		am.deleteMarker();
		p.sendMessage(Text.literal("§aArea deleted successfully"));
	}

}
