package me.mrletsplay.dynmapareas.command.area;

import java.util.List;
import java.util.stream.Collectors;

import org.dynmap.markers.AreaMarker;

import me.mrletsplay.dynmapareas.DynmapAreasMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class AreaListCommand extends FabricCommand {

	public AreaListCommand() {
		super("list");
		setDescription("List all of your areas");
		setUsage("/area list");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		String prefix = p.getUuid().toString() + "_";
		List<AreaMarker> markers = DynmapAreasMod.areaMarkerSet.getAreaMarkers().stream()
				.filter(a -> a.getMarkerID().startsWith(prefix))
				.collect(Collectors.toList());

		if(markers.isEmpty()) {
			p.sendMessage(Text.literal("§cYou haven't created any areas yet"));
			return;
		}

		p.sendMessage(Text.literal("§aYour areas:"));
		for(AreaMarker area : markers) {
			p.sendMessage(Text.literal(String.format("§6%s: §7%s", area.getMarkerID().substring(prefix.length()), area.getLabel())));
		}
	}

}
