package me.mrletsplay.dynmapareas.command.marker;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.dynmap.markers.MarkerIcon;

import me.mrletsplay.dynmapareas.DynmapAreasMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import net.minecraft.util.math.BlockPos;

public class MarkerAddCommand extends FabricCommand {

	public MarkerAddCommand() {
		super("add");
		setDescription("Add a marker to the map");
		setUsage("/area marker <name> <icon>");

		setTabCompleter(event -> {
			if(event.getArgs().length == 0) {
				return Arrays.asList("My fancy marker");
			}else if(event.getArgs().length == 1) {
				List<String> icons = new ArrayList<>();
				for(MarkerIcon i : DynmapAreasMod.markerAPI.getMarkerIcons()) icons.add(i.getMarkerIconID());
				return icons;
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		p.sendMessage(Text.literal("WORLD: " + p.getWorld().getRegistryKey().toString()));

		if(event.getArguments().length != 2) {
			sendCommandInfo(event.getSender());
			return;
		}

		String name = event.getArguments()[0];
		MarkerIcon icon = DynmapAreasMod.markerAPI.getMarkerIcon(event.getArguments()[1]);

		if(icon == null) {
			p.sendMessage(Text.literal("§cInvalid icon"));
			return;
		}

		BlockPos loc = p.getBlockPos();
		DynmapAreasMod.markerMarkerSet.createMarker(p.getUuid().toString() + "_" + Long.toHexString(System.nanoTime()), name, DynmapAreasMod.getWorldName(p.getWorld()), loc.getX() + 0.5, loc.getY(), loc.getZ() + 0.5, icon, true);
		p.sendMessage(Text.literal("§aMarker created"));
	}

}
