package me.mrletsplay.dynmapareas.command.marker;

import java.util.List;
import java.util.stream.Collectors;

import org.dynmap.markers.Marker;

import me.mrletsplay.dynmapareas.DynmapAreasMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class MarkerListCommand extends FabricCommand {

	public MarkerListCommand() {
		super("list");
		setDescription("List all of your markers");
		setUsage("/marker list");
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 0) {
			sendCommandInfo(event.getSender());
			return;
		}

		String prefix = p.getUuid().toString() + "_";
		List<Marker> markers = DynmapAreasMod.markerMarkerSet.getMarkers().stream()
				.filter(a -> a.getMarkerID().startsWith(prefix))
				.collect(Collectors.toList());

		if(markers.isEmpty()) {
			p.sendMessage(Text.literal("§cYou haven't added any markers yet"));
			return;
		}

		p.sendMessage(Text.literal("§aYour markers:"));
		for(Marker marker : markers) {
			p.sendMessage(Text.literal(String.format("§6%s: §7%s", marker.getMarkerID().substring(prefix.length()), marker.getLabel())));
		}
	}

}
