package me.mrletsplay.dynmapareas.command.marker;

import java.util.Arrays;
import java.util.Collections;
import java.util.stream.Collectors;

import org.dynmap.markers.Marker;

import me.mrletsplay.dynmapareas.DynmapAreasMod;
import me.mrletsplay.mrcore.command.event.CommandInvokedEvent;
import me.mrletsplay.mrcore.fabric.command.FabricCommand;
import me.mrletsplay.mrcore.fabric.command.FabricCommandSender;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;

public class MarkerRenameCommand extends FabricCommand {

	public MarkerRenameCommand() {
		super("rename");
		setDescription("Rename a marker");
		setUsage("/marker rename <id> <new name>");

		setTabCompleter(event -> {
			FabricCommandSender sender = (FabricCommandSender) event.getSender();
			ServerPlayerEntity p = sender.asPlayer();
			if(p == null) return Collections.emptyList();

			if(event.getArgs().length == 0) {
				String prefix = p.getUuid().toString() + "_";
				return DynmapAreasMod.markerMarkerSet.getMarkers().stream()
						.filter(a -> a.getMarkerID().startsWith(prefix))
						.map(a -> a.getMarkerID().substring(prefix.length()))
						.collect(Collectors.toList());
			}else if(event.getArgs().length == 1) {
				return Arrays.asList("New name");
			}

			return Collections.emptyList();
		});
	}

	@Override
	public void action(CommandInvokedEvent event) {
		ServerPlayerEntity p = getSenderPlayer(event);
		if(p == null) {
			event.getSender().sendMessage("Player only!");
			return;
		}

		if(event.getArguments().length != 2) {
			sendCommandInfo(event.getSender());
			return;
		}

		Marker m = DynmapAreasMod.markerMarkerSet.findMarker(p.getUuid().toString() + "_" + event.getArguments()[0]);
		if(m == null) {
			p.sendMessage(Text.literal("§cThat marker doesn't exist"));
			return;
		}

		String newName = event.getArguments()[1];
		m.setLabel(newName);

		p.sendMessage(Text.literal("§aMarker renamed successfully"));
	}

}
